
#include <stdalign.h>
#include <stdio.h>
// every object of type struct sse_t will be aligned to 16-byte boundary
// (note: needs support for DR 444)
struct S1 {
  alignas(16) int data[4];
};

// struct data aligned to 32-byte boundary
struct S2 {
  int n;
  alignas(32) char cacheline[32]; // over-aligned array
};

int main(void)
{
    printf("sizeof(struct S2) = %zu (1 char + 31 B padding + 32 B array)\n",
           sizeof(struct S2));

    printf("alignment of S2: %zu\n", alignof(struct S2));

    alignas(256) struct S2 d;

    printf("address: %p\n", &d);
}

