
#include <stdio.h>
#include <stdlib.h>     // rand(),RAND_MAX
#include <time.h>       // time()

unsigned long statistics_copy_n=0;

void insertion_sort(int a[], const unsigned len) {
    int i = len-1;
    while(i>=0) {
        int j=i;
        int temp=a[j];
        while(j<len-1 && a[j+1] < temp) {
            a[j] = a[j+1];
            ++statistics_copy_n;
            ++j;
        }
        a[j] = temp;
        --i;
    }

}

/*

function insertion_sort R
    i ← length R
    while i > 0 do
        j ← i
        temp ← Rj
        while j < length R and Rj+1 < temp do
            Rj ← Rj+1
            j ← j + 1
        Rj ← temp
        i ← i - 1


 Move assignments to and from t out of loop 
void isort3()
{       int i, j;
        DType t;
        for (i = 1; i < n; i++) {
                t = x[i];
                for (j = i; j > 0 && x[j-1] > t; j--)
                        x[j] = x[j-1];
                x[j] = t;
        }
}

*/

void fill_random(int a[], const unsigned N) {
    for(unsigned i=0; i<N; ++i)
        a[i] = rand()/(RAND_MAX/10000);
}

void print(int a[], const unsigned N) {
    printf("{ ");
    for(unsigned i=0; i<N; ++i)
        printf("%d, ",a[i]);
    printf("}\n");
}

int main(int argc, char *argv[]) {
    long int n=10;
    if(argc>1)
        n=atol(argv[1]);
    if(n<2||n>10000000) {
        fprintf(stderr,"Error: bad size\n");
        return 1;
    }
    const unsigned N = n;
    int a[N];   // C99

    srand(time(NULL));
    fill_random(a,N);
    print(a,N);
    insertion_sort(a,N);
    print(a,N);

    printf("N=%u, copy_n=%lu\n",N,statistics_copy_n);

}

