/*
 *
 * Demonstrace zaludne chyby typu BUFFER OVERFLOW (Undefined Behavior)
 *
 * Zkuste:
 *  - prelozit bez optimalizace:   gcc
 *  - prelozit s optimalizaci:     gcc -O3
 *  - program valgrind
 *
 */

#include <stdio.h>

#define N        4		/* velikost pole - cca 4..10 */
#define ERR      1		/* o kolik prekrocime meze - ZKUSTE 1..5 */
#define VAL    'A'		/* CO zapisujeme je take vyznamne - ZKUSTE '\0' */

int main()
{
    int i;                      /* pozor - pravdepodobne bude prepsano */
    char pole[N];               /* buffer je na zásobníku (on stack) */

    printf("Start zapisu (VAL='\\x%02x' dekadicky:%d):\n", VAL, VAL);

    for (i = 0; i < N + ERR; i++) {	/* <<< zde je hruba chyba */
	printf("  nasleduje: pole[%d] = VAL %s\n",
	       i, (i >= N) ? "(>limit!)" : "");
	pole[i] = VAL;		/* chyba typu BUFFER OVERFLOW pro i>=N */
    }

    printf("Konec zapisu, i=%d (očekávaná hodnota je %d)\n", i, N+ERR);

    /*** Chyba se nemusi projevit pro male ERR (zarovnani) */
    /*** nebo se program muze zacyklit pro VAL='\0' (prepise promennou i) */
    /*** nebo muze havarovat kdyz je i v registru a prepise navratovou adresu. */
    /*** Je mozne i jine chovani ... */

    printf("Konec main().\n");
    return pole[0];
}
