
// Test of UTF-8 characters
// Warning: needs UTF-8 localization and terminal

// TODO: function int utf8seq_len(const char*s);// ascii=1, 0b10xxxxxx=-1,
//                                              // 0b110=2, 0b1110=3 ... to 6?
//       const char * skip_utf8_(const char*s); // skip 0b10xxxxxx

#include <stdio.h>
#include <locale.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

int32_t get_utf8(const char ** p) {
    const char *s = *p;
    int32_t codepoint = 0;
//    mbtowc(NULL, NULL, 0);    // reset state
    int len = mbtowc(&codepoint, s, strlen(s));
    if(len<0) {
        fprintf(stderr,"len=%d\n",len);
        fprintf(stderr,"Error in UTF-8 sequence or bad locale, exiting...\n");
        exit(1);
    }
    *p = s + len;       // shift to next UTF-8 sequence
    return codepoint;
}

const char * const msg = "UTF-8: ěščřžýáíé \U0001f596 ";

int main(void) {
    setlocale(LC_CTYPE,"");
    printf("string = \"%s\"\n", msg);
    printf("strlen(string) = %td\n", strlen(msg));
    int32_t c;
    const char * s = msg;
    const char * p = s;
    int i = 0;
    while((c=get_utf8(&s))!='\0') {
        printf("[%02d] ",i);
        ++i;
        int len = s-p;
        char buf[len+1];
        strncpy(buf,p,len);
        buf[len]='\0';
        p=s;
        printf("codepoint = %4X ",c);
        printf("'%s' ", buf);
        for(int j=0; j<len; ++j)
            printf("%2X ", (unsigned char)buf[j]);
        printf("\n");
    }
    printf("Total %d codepoints\n", i);
}
